Weak::MARC4_Base Class Reference

MARC4 base class. More...

`#include <arc4.h>`

Inheritance diagram for Weak::MARC4_Base:

## Public Types

typedef SymmetricCipherFinal< MARC4_Base > | Encryption
typedef SymmetricCipherFinal< MARC4_Base > | Decryption
Public Types inherited from Weak::ARC4_Base
typedef SymmetricCipherFinal< ARC4_Base > | Encryption
typedef SymmetricCipherFinal< ARC4_Base > | Decryption
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Types inherited from SymmetricCipherDocumentation
typedef SymmetricCipher | Encryption
| implements the SymmetricCipher interface
typedef SymmetricCipher | Decryption
| implements the SymmetricCipher interface

## Static Public Member Functions

static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from Weak::ARC4_Base
static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from VariableKeyLength< 16, 1, 256 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| Provides a valid key length for the algorithm provided by a static function.

## Additional Inherited Members

Public Member Functions inherited from Weak::ARC4_Base
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes.
void | DiscardBytes (size_t n)
| Generate and discard n bytes.
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes.
bool | IsRandomAccess () const
| Determines whether the cipher supports random access.
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting.
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction.
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values.
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy.
virtual byte | GenerateByte ()
| Generate new random byte and return it.
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it.
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive.
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation.
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length.
virtual size_t | DefaultKeyLength () const =0
| Returns default key length.
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm.
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual void | Seek (lword pos)
| Seek to an absolute position.
Static Public Attributes inherited from VariableKeyLength< 16, 1, 256 >
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant.
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant.
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | KEYLENGTH_MULTIPLE
| The key length multiple used by the algorithm provided as a constant.
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant.
static const int | IV_LENGTH
| The default initialization vector length for the algorithm provided as a constant.

## Detailed Description

MARC4 base class.

Implementations and overrides in `Base` apply to both `ENCRYPTION` and `DECRYPTION` directions

MARC4 discards the first 256 bytes of keystream, which may be weaker than the rest

Since
  Crypto++ 3.1

Definition at line 58 of file arc4.h.

## Member Typedef Documentation

## Encryption

typedef SymmetricCipherFinal<MARC4_Base> Weak::MARC4_Base::Encryption

Definition at line 63 of file arc4.h.

## Decryption

typedef SymmetricCipherFinal<MARC4_Base> Weak::MARC4_Base::Decryption

Definition at line 64 of file arc4.h.

## Member Function Documentation

## StaticAlgorithmName()

static const char * Weak::MARC4_Base::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 61 of file arc4.h.

The documentation for this class was generated from the following file:

- arc4.h